-- Этот файл содержит vhdl описание УА, созданное автоматически Quartus II
-- по графу переходов УА
-- чтобы использовать этот модуль в проекте в качестве УА 
-- необходимо создать файл конфигурации,  
-- в котором следует указать 
-- for unit_YA : ControlUnit use entity work.SM_mealy;
-- Generated by Quartus II Version 13.1.0 Build 162 10/23/2013 SJ Web Edition
-- Created on Mon Jan 07 23:38:56 2019

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY SM_mealy IS
    PORT (
        set : IN STD_LOGIC := '0';
        clk : IN STD_LOGIC;
        x : IN STD_LOGIC_VECTOR(2 DOWNTO 0) := "000";
        sno : IN STD_LOGIC := '0';
        y : OUT STD_LOGIC_VECTOR(8 DOWNTO 0);
        sko : OUT STD_LOGIC
    );
END SM_mealy;

ARCHITECTURE BEHAVIOR OF SM_mealy IS
    TYPE type_fstate IS (s0,s1,s2);
    SIGNAL fstate : type_fstate;
    SIGNAL reg_fstate : type_fstate;
BEGIN
    PROCESS (clk,set,reg_fstate)
    BEGIN
        IF (set='1') THEN
            fstate <= s0;
        ELSIF (clk='1' AND clk'event) THEN
            fstate <= reg_fstate;
        END IF;
    END PROCESS;

    PROCESS (fstate,x,sno)
    BEGIN
        y <= "000000000";
        sko <= '0';
        CASE fstate IS
            WHEN s0 =>
                IF (NOT((sno = '1'))) THEN
                    reg_fstate <= s0;
                ELSIF ((sno = '1')) THEN
                    reg_fstate <= s1;
                -- Inserting 'else' block to prevent latch inference
                ELSE
                    reg_fstate <= s0;
                END IF;

                IF (NOT((sno = '1'))) THEN
                    y <= "000000000";
                ELSIF ((sno = '1')) THEN
                    y <= "000001111";
                -- Inserting 'else' block to prevent latch inference
                ELSE
                    y <= "000000000";
                END IF;
            WHEN s1 =>
                IF ((x(0) = '1')) THEN
                    reg_fstate <= s2;
                ELSIF ((NOT((x(0) = '1')) AND (x(2) = '1'))) THEN
                    reg_fstate <= s0;
                ELSIF ((NOT((x(0) = '1')) AND NOT((x(2) = '1')))) THEN
                    reg_fstate <= s1;
                -- Inserting 'else' block to prevent latch inference
                ELSE
                    reg_fstate <= s1;
                END IF;

                IF ((NOT((x(0) = '1')) AND (x(2) = '1'))) THEN
                    sko <= '1';
                -- Inserting 'else' block to prevent latch inference
                ELSE
                    sko <= '0';
                END IF;

                IF ((NOT((x(0) = '1')) AND NOT((x(2) = '1')))) THEN
                    y <= "111000000";
                ELSIF (((x(0) = '1') AND (x(1) = '1'))) THEN
                    y <= "000010000";
                ELSIF (((x(0) = '1') AND NOT((x(1) = '1')))) THEN
                    y <= "000100000";
                -- Inserting 'else' block to prevent latch inference
                ELSE
                    y <= "000000000";
                END IF;
            WHEN s2 =>
                IF ((x(2) = '1')) THEN
                    reg_fstate <= s0;
                ELSIF (NOT((x(2) = '1'))) THEN
                    reg_fstate <= s1;
                -- Inserting 'else' block to prevent latch inference
                ELSE
                    reg_fstate <= s2;
                END IF;

                IF ((x(2) = '1')) THEN
                    sko <= '1';
                -- Inserting 'else' block to prevent latch inference
                ELSE
                    sko <= '0';
                END IF;

                IF (NOT((x(2) = '1'))) THEN
                    y <= "111000000";
                -- Inserting 'else' block to prevent latch inference
                ELSE
                    y <= "000000000";
                END IF;
            WHEN OTHERS => 
                y <= "XXXXXXXXX";
                sko <= 'X';
                report "Reach undefined state";
        END CASE;
    END PROCESS;
END BEHAVIOR;
